import 'device_properties_platform_interface.dart';

class DeviceProperties {
  Future<DevicesPropertiesModel?> getDevicesProperties() {
    return DevicePropertiesPlatform.instance.getProperties();
  }
}

class DevicesPropertiesModel {
  String? ipAddress;
  String? deviceType;
  String? osVersion;
  String? versionCode;

  DevicesPropertiesModel({
    this.ipAddress,
    this.deviceType,
    this.osVersion,
    this.versionCode,
  });

  factory DevicesPropertiesModel.fromJson(Map<String, dynamic> json) {
    return DevicesPropertiesModel(
      ipAddress: json['ip_address'] as String?,
      deviceType: json['device_type'] as String?,
      osVersion: json['os_version'] as String?,
      versionCode: json['version_code'] as String?,
    );
  }

  Map<String, dynamic> toJson() => {
        'ip_address': ipAddress,
        'device_type': deviceType,
        'os_version': osVersion,
        'version_code': versionCode,
      };
}
