import 'dart:convert';

import 'package:device_properties/device_properties.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';

import 'device_properties_platform_interface.dart';

/// An implementation of [DevicePropertiesPlatform] that uses method channels.
class MethodChannelDeviceProperties extends DevicePropertiesPlatform {
  /// The method channel used to interact with the native platform.
  @visibleForTesting
  final methodChannel = const MethodChannel('device_properties');

  @override
  Future<DevicesPropertiesModel?> getProperties() async {
    try {
      final version = await methodChannel.invokeMethod<String>('getProperties');
      return DevicesPropertiesModel.fromJson(jsonDecode(version!));
    } catch (e) {
      return null;
    }
  }
}
