import 'package:device_properties/device_properties.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'device_properties_method_channel.dart';

abstract class DevicePropertiesPlatform extends PlatformInterface {
  /// Constructs a DevicePropertiesPlatform.
  DevicePropertiesPlatform() : super(token: _token);

  static final Object _token = Object();

  static DevicePropertiesPlatform _instance = MethodChannelDeviceProperties();

  /// The default instance of [DevicePropertiesPlatform] to use.
  ///
  /// Defaults to [MethodChannelDeviceProperties].
  static DevicePropertiesPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [DevicePropertiesPlatform] when
  /// they register themselves.
  static set instance(DevicePropertiesPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<DevicesPropertiesModel?> getProperties() {
    throw UnimplementedError('getProperties() not inplement');
  }
}
