import 'package:flutter_test/flutter_test.dart';
import 'package:device_properties/device_properties.dart';
import 'package:device_properties/device_properties_platform_interface.dart';
import 'package:device_properties/device_properties_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockDevicePropertiesPlatform
    with MockPlatformInterfaceMixin
    implements DevicePropertiesPlatform {
  @override
  Future<DevicesPropertiesModel?> getProperties() => Future.value(null);
}

void main() {
  final DevicePropertiesPlatform initialPlatform = DevicePropertiesPlatform.instance;

  test('$MethodChannelDeviceProperties is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelDeviceProperties>());
  });

  test('getProperties', () async {
    DeviceProperties devicePropertiesPlugin = DeviceProperties();
    MockDevicePropertiesPlatform fakePlatform = MockDevicePropertiesPlatform();
    DevicePropertiesPlatform.instance = fakePlatform;
    expect(await devicePropertiesPlugin.getDevicesProperties(), null);
  });
}
